The FormatterBase class can be used to create a new custom formatter. For example:
You can then add the format(obj, formattedData) method to define the rule for format and the color for cell text, where:
obj: The raw cell value.
formattedData.conditionalForeColor: Helps color text (optional); set its value to a color string to apply the rule.
The format method returns a formatted string. You can set color text based on a value range at the same time. For example:
Then you can add the parse(str) method to return a value parsed from the specified string.
var spreadNS = GC.Spread.Sheets;
function CustomDateFormat() {
}
CustomDateFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomDateFormat.prototype.format = function (obj, formattedData) {
var date = new Date(obj);
if (date instanceof Date && isFinite(date)) {
if (date.getFullYear() > 1990 && formattedData) {
formattedData.conditionalForeColor = "blue";
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return (date.getMonth() + 1) + "/" + date.getDate() + "/" + date.getFullYear();
}
else {
return obj != null ? obj.toString() : "";
}
};
CustomDateFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
function CustomNumberFormat() {
}
CustomNumberFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomNumberFormat.prototype.format = function (obj, formattedData) {
if (typeof obj === "number") {
return formatNumber(obj, formattedData);
} else if (typeof obj === "string") {
if (Number.isFinite(+obj)) {
return formatNumber(parseFloat(obj), formattedData);
}
}
return obj ? obj.toString() : "";
};
function formatNumber(value, formattedData) {
if (isFinite(value) && formattedData) {
if (value >= 10) {
formattedData.conditionalForeColor = "green";
} else if (value > 0) {
formattedData.conditionalForeColor = "gold";
} else {
formattedData.conditionalForeColor = "blue";
}
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return value.toString();
}
CustomNumberFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 1});
initSpread(spread);
};
function initSpread(spread) {
var sheet = spread.getSheet(0);
spread.suspendPaint();
sheet.name("Custom Formatter");
initData(sheet);
spread.resumePaint();
};
function initData(sheet) {
sheet.setArray(0, 0, [
[123, new Date(2002, 2, 6)],
["-18", "1988/3/2"],
["0", "Oct 9, 2011"],
[4, 4],
[NaN, NaN],
[Infinity, Infinity]
]);
for (var c = 0; c < 2; c++) {
sheet.setColumnWidth(c, 120);
}
sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
sheet.getRange(0, 1, 6, 2).formatter(new CustomDateFormat());
sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
};
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row" style="padding:2px 10px">
<p>
Change the values. The cells have custom formatters set to display certain colors according to specific conditions:<br />
- Gold if the number is positive<br />
- Green if the number is bigger than 9<br />
- Blue if the date is after 1990<br />
Otherwise, the color of the cell is red.
</p>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

The FormatterBase class can be used to create a new custom formatter. For example:
You can then add the format(obj, formattedData) method to define the rule for format and the color for cell text, where:
obj: The raw cell value.
formattedData.conditionalForeColor: Helps color text (optional); set its value to a color string to apply the rule.
The format method returns a formatted string. You can set color text based on a value range at the same time. For example:
Then you can add the parse(str) method to return a value parsed from the specified string.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = true;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
let sheet = spread.getSheet(0);
sheet.name("Custom Formatter");
this.initData(sheet);
spread.resumePaint();
}
initData(sheet) {
let spreadNS = GC.Spread.Sheets;
sheet.setArray(0, 0, [
[123, new Date(2002, 2, 6)],
["-18", "1988/3/2"],
["0", "Oct 9, 2011"],
[4, 4],
[NaN, NaN],
[Infinity, Infinity]
]);
for (let c = 0; c < 2; c++) {
sheet.setColumnWidth(c, 120);
}
sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
sheet.getRange(0, 1, 6, 2).formatter(new CustomDateFormat());
sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
}
}
function CustomDateFormat() {
}
CustomDateFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomDateFormat.prototype.format = function (obj, formattedData) {
let date = new Date(obj);
if (date instanceof Date && isFinite(date)) {
if (date.getFullYear() > 1990 && formattedData) {
formattedData.conditionalForeColor = "blue";
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return (date.getMonth() + 1) + "/" + date.getDate() + "/" + date.getFullYear();
}
else {
return obj != null ? obj.toString() : "";
}
};
CustomDateFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
function CustomNumberFormat() {
}
CustomNumberFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomNumberFormat.prototype.format = function (obj, formattedData) {
if (typeof obj === "number") {
return formatNumber(obj, formattedData);
} else if (typeof obj === "string") {
if (Number.isFinite(+obj)) {
return formatNumber(parseFloat(obj), formattedData);
}
}
return obj ? obj.toString() : "";
};
function formatNumber(value, formattedData) {
if (isFinite(value) && formattedData) {
if (value >= 10) {
formattedData.conditionalForeColor = "green";
} else if (value > 0) {
formattedData.conditionalForeColor = "gold";
} else {
formattedData.conditionalForeColor = "blue";
}
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return value.toString();
}
CustomNumberFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet [autoGenerateColumns]='autoGenerateColumns'>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row" style="padding:2px 10px">
<p>
Change the values. The cells have custom formatters set to display certain colors according to specific conditions:<br />
- Gold if the number is positive<br />
- Green if the number is bigger than 9<br />
- Blue if the date is after 1990<br />
Otherwise, the color of the cell is red.
</p>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

The FormatterBase class can be used to create a new custom formatter. For example:
You can then add the format(obj, formattedData) method to define the rule for format and the color for cell text, where:
obj: The raw cell value.
formattedData.conditionalForeColor: Helps color text (optional); set its value to a color string to apply the rule.
The format method returns a formatted string. You can set color text based on a value range at the same time. For example:
Then you can add the parse(str) method to return a value parsed from the specified string.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet :autoGenerateColumns='autoGenerateColumns'>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row" style="padding:2px 10px">
<p>
Change the values. The cells have custom formatters set to display certain colors according to specific
conditions:<br />
- Gold if the number is positive<br />
- Green if the number is bigger than 9<br />
- Blue if the date is after 1990<br />
Otherwise, the color of the cell is red.
</p>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref } from "vue";
import GC from "@mescius/spread-sheets";
const spreadRef = ref(null);
const autoGenerateColumns = ref(false);
function initSpread(spread) {
spreadRef.value = spread;
spread.suspendPaint();
let sheet = spread.getSheet(0);
sheet.name("Custom Formatter");
initData(sheet);
spread.resumePaint();
}
function initData(sheet) {
sheet.setArray(0, 0, [
[123, new Date(2002, 2, 6)],
["-18", "1988/3/2"],
["0", "Oct 9, 2011"],
[4, 4],
[NaN, NaN],
[Infinity, Infinity]
]);
for (let c = 0; c < 2; c++) {
sheet.setColumnWidth(c, 120);
}
sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
sheet.getRange(0, 1, 6, 2).formatter(new CustomDateFormat());
sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
}
let spreadNS = GC.Spread.Sheets;
function CustomDateFormat() {
}
CustomDateFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomDateFormat.prototype.format = function (obj, formattedData) {
let date = new Date(obj);
if (date instanceof Date && isFinite(date)) {
if (date.getFullYear() > 1990 && formattedData) {
formattedData.conditionalForeColor = "blue";
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return (date.getMonth() + 1) + "/" + date.getDate() + "/" + date.getFullYear();
}
else {
return obj != null ? obj.toString() : "";
}
};
CustomDateFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
function CustomNumberFormat() {
}
CustomNumberFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomNumberFormat.prototype.format = function (obj, formattedData) {
if (typeof obj === "number") {
return formatNumber(obj, formattedData);
} else if (typeof obj === "string") {
if (Number.isFinite(+obj)) {
return formatNumber(parseFloat(obj), formattedData);
}
}
return obj ? obj.toString() : "";
};
function formatNumber(value, formattedData) {
if (isFinite(value) && formattedData) {
if (value >= 10) {
formattedData.conditionalForeColor = "green";
} else if (value > 0) {
formattedData.conditionalForeColor = "gold";
} else {
formattedData.conditionalForeColor = "blue";
}
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return value.toString();
}
CustomNumberFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

The FormatterBase class can be used to create a new custom formatter. For example:
You can then add the format(obj, formattedData) method to define the rule for format and the color for cell text, where:
obj: The raw cell value.
formattedData.conditionalForeColor: Helps color text (optional); set its value to a color string to apply the rule.
The format method returns a formatted string. You can set color text based on a value range at the same time. For example:
Then you can add the parse(str) method to return a value parsed from the specified string.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
function CustomDateFormat() {
}
CustomDateFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomDateFormat.prototype.format = function (obj, formattedData) {
let date = new Date(obj);
if (date instanceof Date && isFinite(date)) {
if (date.getFullYear() > 1990 && formattedData) {
formattedData.conditionalForeColor = "blue";
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return (date.getMonth() + 1) + "/" + date.getDate() + "/" + date.getFullYear();
}
else {
return obj != null ? obj.toString() : "";
}
};
CustomDateFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
function CustomNumberFormat() {
}
CustomNumberFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomNumberFormat.prototype.format = function (obj, formattedData) {
if (typeof obj === "number") {
return formatNumber(obj, formattedData);
} else if (typeof obj === "string") {
if (Number.isFinite(+obj)) {
return formatNumber(parseFloat(obj), formattedData);
}
}
return obj ? obj.toString() : "";
};
function formatNumber(value, formattedData) {
if (isFinite(value) && formattedData) {
if (value >= 10) {
formattedData.conditionalForeColor = "green";
} else if (value > 0) {
formattedData.conditionalForeColor = "gold";
} else {
formattedData.conditionalForeColor = "blue";
}
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return value.toString();
}
CustomNumberFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
export function AppFunc() {
let spread = null;
let autoGenerateColumns = true;
const initSpread = (currSpread) => {
spread = currSpread;
spread.suspendPaint();
let sheet = spread.getSheet(0);
sheet.name("Custom Formatter");
initData(sheet);
spread.resumePaint();
}
const initData = (sheet) => {
let spreadNS = GC.Spread.Sheets;
sheet.setArray(0, 0, [
[123, new Date(2002, 2, 6)],
["-18", "1988/3/2"],
["0", "Oct 9, 2011"],
[4, 4],
[NaN, NaN],
[Infinity, Infinity]
]);
for (let c = 0; c < 2; c++) {
sheet.setColumnWidth(c, 120);
}
sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
sheet.getRange(0, 1, 6, 2).formatter(new CustomDateFormat());
sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
};
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
<Worksheet autoGenerateColumns={autoGenerateColumns}>
</Worksheet>
</SpreadSheets>
</div>
<Panel />
</div>;
}
function Panel() {
return (
<div class="options-container">
<div className="option-row" style={{ padding: '2px 10px' }}>
<p>
Change the values. The cells have custom formatters set to display certain colors according to specific conditions:<br />
- Gold if the number is positive<br />
- Green if the number is bigger than 9<br />
- Blue if the date is after 1990<br />
Otherwise, the color of the cell is red.
</p>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const Component = React.Component;
function CustomDateFormat() {
}
CustomDateFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomDateFormat.prototype.format = function (obj, formattedData) {
let date = new Date(obj);
if (date instanceof Date && isFinite(date)) {
if (date.getFullYear() > 1990 && formattedData) {
formattedData.conditionalForeColor = "blue";
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return (date.getMonth() + 1) + "/" + date.getDate() + "/" + date.getFullYear();
}
else {
return obj != null ? obj.toString() : "";
}
};
CustomDateFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
function CustomNumberFormat() {
}
CustomNumberFormat.prototype = new GC.Spread.Formatter.FormatterBase();
CustomNumberFormat.prototype.format = function (obj, formattedData) {
if (typeof obj === "number") {
return formatNumber(obj, formattedData);
} else if (typeof obj === "string") {
if (Number.isFinite(+obj)) {
return formatNumber(parseFloat(obj), formattedData);
}
}
return obj ? obj.toString() : "";
};
function formatNumber(value, formattedData) {
if (isFinite(value) && formattedData) {
if (value >= 10) {
formattedData.conditionalForeColor = "green";
} else if (value > 0) {
formattedData.conditionalForeColor = "gold";
} else {
formattedData.conditionalForeColor = "blue";
}
} else if (formattedData) {
formattedData.conditionalForeColor = "red";
}
return value.toString();
}
CustomNumberFormat.prototype.parse = function (str) {
return new GC.Spread.Formatter.GeneralFormatter().parse(str);
};
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.autoGenerateColumns = true;
}
render() {
return <div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread=>this.initSpread(spread)}>
<Worksheet autoGenerateColumns={this.autoGenerateColumns}>
</Worksheet>
</SpreadSheets>
</div>
<Panel/>
</div>;
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
let sheet = spread.getSheet(0);
sheet.name("Custom Formatter");
this.initData(sheet);
spread.resumePaint();
}
initData(sheet) {
let spreadNS = GC.Spread.Sheets;
sheet.setArray(0, 0, [
[123, new Date(2002, 2, 6)],
["-18", "1988/3/2"],
["0", "Oct 9, 2011"],
[4, 4],
[NaN, NaN],
[Infinity, Infinity]
]);
for (let c = 0; c < 2; c++) {
sheet.setColumnWidth(c, 120);
}
sheet.getRange(0, 0, 6, 2).formatter(new CustomNumberFormat());
sheet.getRange(0, 1, 6, 2).formatter(new CustomDateFormat());
sheet.setText(0, 0, "Custom Number", spreadNS.SheetArea.colHeader);
sheet.setText(0, 1, "Custom Date", spreadNS.SheetArea.colHeader);
};
}
class Panel extends Component{
constructor(props){
super(props);
}
render(){
return(
<div class="options-container">
<div className="option-row" style={{padding: '2px 10px'}}>
<p>
Change the values. The cells have custom formatters set to display certain colors according to specific conditions:<br />
- Gold if the number is positive<br />
- Green if the number is bigger than 9<br />
- Blue if the date is after 1990<br />
Otherwise, the color of the cell is red.
</p>
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);